%--------------------------------------------------------%
%  Prise en compte des conditions aux limites de         %
%  Dirichlet                                             %
%                                                        %
%  C. Besse, IMT Toulouse, 2018                          %
%--------------------------------------------------------%

function [A,rhs]=cond_lim_dirichlet(m,A,rhs,CL,zones)
% Prise en compte des conditions aux limites
% Determination des points du bords 
% Dans ls structure GMSH, les points du bord composent les lignes au bord
% mais ne sont pas forcement ranges dans un ordre pre-defini
  
  test_ibc=m.LINES(:,3)==zones(1);
  for k=2:length(zones)
    test_ibc=test_ibc|m.LINES(:,3)==zones(k);
  end
  ibc=find(test_ibc);
  
  noeud_bord=zeros(m.nbLines,2);
  vu=zeros(m.nbNod,1);
  k1=0;
  for jj=1:length(ibc)
    j=ibc(jj);
    p1=m.LINES(j,1);
    p2=m.LINES(j,2);
    type=m.LINES(j,3);    
    if not(vu(p1))
      k1=k1+1;
      noeud_bord(k1,1)=p1;
      noeud_bord(k1,2)=type;
      vu(p1)=k1;
    end
    if not(vu(p2))
      k1=k1+1;
      noeud_bord(k1,1)=p2;
      noeud_bord(k1,2)=type;        
      vu(p2)=k1;
    end
  end

  vec_cl=zeros(m.nbNod,1);
  val_CL=CL;
  for j=1:k1
    p=noeud_bord(j,1);
    type=noeud_bord(j,2);
% $$$     if max(type==zones)
% $$$       % if (type==1001)||(type==1003)||(type==1004)
% $$$       % Test utile si on avait plusieurs zones differentes au bord
% $$$       val_CL=CL;
% $$$     end
    vec_cl(p)=val_CL;
    % On multiplie la p-ieme colonne de la matrice par la valeur CL, et on
    % la soustrait au second membre. Le but est de laisser la matrice
    % symetrique
    rhs=rhs-A*vec_cl;
    vec_cl(p)=0;
    % La p-ieme ligne et la p-ieme colonne de la matrice sont remplacees
    % par une ligne  et une colonne de zeros.
    A(p,:)=0;A(:,p)=0;
    % Le terme App est remplacee par 1.
    A(p,p)=1;
    % La composante rhs(p) est remplacee par CL.
    rhs(p)=val_CL;
  end
