%--------------------------------------------------------%
%  Prise en compte des conditions aux limites liees      %
%  aux conditions de transmission                        %
%                                                        %
%  Methode de Schwarz Waveform Relaxation                %
%                                                        %
%  C. Besse, IMT Toulouse, 2018                          %
%--------------------------------------------------------%
function [B]=cond_lim_dom_phys2(m,dom_phys,A,p)
  ind_rep_bc_dom=find(m.LINES(:,3)==dom_phys);

  B=A;
  
  for ll=1:length(ind_rep_bc_dom)
    l=ind_rep_bc_dom(ll);
    %reperer les points du segment du bord
    k1=m.LINES(l,1); %correspond au point A1
    k2=m.LINES(l,2); %correspond au point A2

    %relever les coordonnees des points
    x1=m.POS(k1,1); y1=m.POS(k1,2); %coordonnees du point A1
    x2=m.POS(k2,1); y2=m.POS(k2,2); %coordonnees du point A2

    %calcul de la longueur du segment
    long=sqrt((x2-x1)^2+(y2-y1)^2);

    % creation de la matrice de masse locale
    Mloc=(long/6)*[2,1;1,2;];
    
    %remplissage de la matrice de masse
    B(k1,k1)=B(k1,k1)+p*Mloc(1,1);    B(k1,k2)=B(k1,k2)+p*Mloc(1,2);    
    B(k2,k1)=B(k2,k1)+p*Mloc(2,1);    B(k2,k2)=B(k2,k2)+p*Mloc(2,2);    

  end
