%--------------------------------------------------------%
%  Resolution de l'equation de Poisson par methode       %
%                d'elements finis                        %
%                                                        %
%  Conditions aux limites de Dirichlet homogenes         %
%                                                        %
%  C. Besse, IMT Toulouse, 2018                          %
%--------------------------------------------------------%

clear all;
close all;

CL=0;
% Identification des bords physiques ou imposer les conditions
% aux limites de Dirichlet
Bord1=1001;
Bord2=1002;
Bord3=1003;
Bord4=1004;

% Chargement du maillage
m=load_gmsh('Maillages/ef_glob.msh');

% Assemblage des matrices de masse, de rigite
% et du second membre (depend de la fonction fun_s.m)
[M,R,rhs]=assemblage(m);

% Matrice du systeme lineaire.
A=R;

% Prise en compte des conditions aux limites de Dirichlet sur les bords
% du domaine
[A,rhs]=cond_lim_dirichlet(m,A,rhs,CL,[Bord1;Bord2;Bord3;Bord4]);

% Resolution du systeme lineaire
sol=A\rhs;

figure(1);
p=trace_sol(m,sol);