%--------------------------------------------------------%
%  Mise a jour de la dreivee normale au bord du domaine  %
%  identifie par dom_phys                                %
%                                                        %
%  Methode de Schwarz Waveform Relaxation                %
%                                                        %
%  C. Besse, IMT Toulouse, 2018                          %
%--------------------------------------------------------%
function [dnu]=update_dnu2(m,dom_phys,p,u,v,dnv)
  ind_rep_bc_dom=find(m.LINES(:,3)==dom_phys);

  dnu=zeros(size(dnv));
  
  for ll=1:length(ind_rep_bc_dom)
    l=ind_rep_bc_dom(ll);
    %reperer les points du segment du bord
    k1=m.LINES(l,1); %correspond au point A1
    k2=m.LINES(l,2); %correspond au point A2

    %relever les coordonnees des points
    x1=m.POS(k1,1); y1=m.POS(k1,2); %coordonnees du point A1
    x2=m.POS(k2,1); y2=m.POS(k2,2); %coordonnees du point A2

    %calcul de la longueur du segment
    long=sqrt((x2-x1)^2+(y2-y1)^2);

    % creation de la matrice de masse locale
    Mloc=(long/6)*[2,1;1,2;];
    
    %remplissage du second membre
    dnu([k1;k2])=-p*Mloc*[u(k1);u(k2)]+dnv([k1;k2])+p*Mloc*[v(k1);v(k2)];
  end
