%--------------------------------------------------------%
%  Optimisation des parametres p et q pour               %
%  pour la methode de Schwarz Waveform Relaxation        %
%                                                        %
%  C. Besse, IMT Toulouse, 2018                          %
%--------------------------------------------------------%

clear all; close all;

%nu=0.01;a=1;c=0;
nu=1;a=0;c=0;

dt=1e-2;
T=1;
omeg=linspace(pi/T,pi/dt,1000)';
delta=@(om) sqrt(a^2+4*nu*(c+om));
L=0.05;
%L=0;
p=linspace(0,10,100)';
q=linspace(0,10,100)';
res=zeros(length(p),length(q));
for j=1:length(p)
  for k=1:length(q)
    res(j,k)=max(abs(((delta(omeg))-p(j)-2*nu*q(k)*omeg)./((delta(omeg))+p(j)+2*nu*q(k)*omeg)).^2.*exp(-(L/nu)*real((delta(omeg)))));
  end
end
[P,Q]=meshgrid(p,q);
mesh(Q,P,res)
set(gca,'fontsize',12);
xlabel('p','fontsize',12)
zlabel('max_{\omega} |\rho_1|','fontsize',12)
ylabel('q','fontsize',12)