%--------------------------------------------------------%
%  Optimisation du parametre p pour                      %
%  pour la methode de Schwarz Waveform Relaxation        %
%                                                        %
%  C. Besse, IMT Toulouse, 2018                          %
%--------------------------------------------------------%

clear all; close all;

%nu=0.01;a=1;c=0;
nu=1;a=1;c=0;

dt=1e-2;
T=1;
omeg=linspace(pi/T,pi/dt,1000)';
delta=@(om) sqrt(a^2+4*nu*(c+om));

% Valeur de l'overlap
L=0.05;
%L=0;
p=linspace(0,20,500)';
res=zeros(length(p),1);
for j=1:length(p)
    res(j)=max(abs(((delta(omeg))-p(j))./((delta(omeg))+p(j))).^2.*exp(-(L/nu)*real((delta(omeg)))));
end
plot(p,res)