import matplotlib.pyplot as plt
import numpy as np

def trace_maillage_phys(m,dom_phys,ax):
    """
    --------------------------------------------------------
    Representation des maillages issus de Gmsh            
                                                        
    C. Besse, IMT Toulouse, 2014                          
    --------------------------------------------------------
    """
    test_ibc=m["TRIANGLES"][:,3]==dom_phys
    (ind,)=test_ibc.nonzero()
    triang=m["TRIANGLES"][ind,0:3]
    xx=m["POS"][:,0]
    yy=m["POS"][:,1]

    pt=ax.plot_trisurf(xx,yy,np.zeros(xx.size),triangles=triang)
    pt.set_facecolor('w')
    return pt

def trace_sol_phys(m,sol,dom_phys,ax):
    """
    --------------------------------------------------------
      Representation des solutions d'une EDP sur maillages  
      issus de Gmsh                                         
      C. Besse, IMT Toulouse, 2018                          
    --------------------------------------------------------
    """
    test_ibc=m["TRIANGLES"][:,3]==dom_phys
    (ind,)=test_ibc.nonzero()
    triang=m["TRIANGLES"][ind,0:3]
    xx=m["POS"][:,0]
    yy=m["POS"][:,1]
    zz=sol.copy()

    pt=ax.plot_trisurf(xx,yy,zz,triangles=triang,cmap=plt.cm.Greys)
    pt.set_facecolor('w')
    return pt
