#--------------------------------------------------------#
#  Optimisation du parametre p pour                      #
#  pour la methode de Schwarz Waveform Relaxation        #
#                                                        #
#  C. Besse, IMT Toulouse, 2018                          #
#--------------------------------------------------------#

import numpy as np
import matplotlib.pylab as plt
plt.ion()

#nu=0.01;a=1;c=0;
nu=1;a=1;c=0;

dt=1e-2
T=1
omeg=np.linspace(np.pi/T,np.pi/dt,1000)
delta = (lambda om: np.sqrt(a**2+4*nu*(c+om)))

# Valeur de l'overlap
ov=0.05
#ov=0
p=np.linspace(0,20,500)
res=np.zeros(p.shape[0])
for j in range(p.shape[0]):
    res[j]=(np.abs(((delta(omeg))-p[j])/((delta(omeg))+p[j]))**2*np.exp(-(ov/nu)*np.real((delta(omeg))))).max();

plt.plot(p,res)

print("p optimal : ",p[np.argmin(res)])
